﻿'
' Copyright (c) 2021, MindFusion LLC - Bulgaria.
'


''' <summary>
''' Interaction logic for MainWindow.xaml
''' </summary>
Partial Public Class MainWindow
	Inherits Window
	Public Sub New()
		InitializeComponent()

		diagram.DefaultShape = Shapes.Ellipse

		Dim b1 As ShapeNode = diagram.Factory.CreateShapeNode(40, 40, 135, 60)
		Dim b2 As ShapeNode = diagram.Factory.CreateShapeNode(385, 40, 135, 60)

		Dim link As DiagramLink = diagram.Factory.CreateDiagramLink(b1, b2)

		Dim b3 As ShapeNode = diagram.Factory.CreateShapeNode(195, 270, 135, 60)
		b3.Text = "Draw a new link from here to the link above."
	End Sub

	Private Sub diagram_LinkCreated(ByVal sender As Object, ByVal e As LinkEventArgs)
		Dim a As DiagramLink = e.Link
		' if not connected to a real node
		If TypeOf a.Destination Is DummyNode Then
			Dim endPt As Point = a.EndPoint
			a.Locked = True
			' so we can exclude it from the search
			Dim trg As DiagramLink = diagram.GetLinkAt(endPt, 6, True)
			If trg IsNot Nothing Then
				Dim n1 As DiagramNode = trg.Origin
				Dim n2 As DiagramNode = trg.Destination
				Dim n3 As DiagramNode = a.Origin

				Dim connector As ShapeNode = diagram.Factory.CreateShapeNode(endPt.X - 9.6, endPt.Y - 9.6, 19.2, 19.2)
				connector.Shape = Shapes.Decision

				diagram.Factory.CreateDiagramLink(connector, n1)
				diagram.Factory.CreateDiagramLink(connector, n2)
				diagram.Factory.CreateDiagramLink(connector, n3)

				diagram.Links.Remove(trg)

				' setup the connector box
				diagram.Selection.Clear()
				connector.Selected = True
				connector.HandlesStyle = HandlesStyle.MoveOnly
				connector.Brush = Brushes.Khaki
			End If

			diagram.Links.Remove(a)
		End If
	End Sub

	Private Sub diagram_MouseMove(ByVal sender As Object, ByVal e As MouseEventArgs)
		If e.LeftButton = MouseButtonState.Pressed Then
			Dim pt As Point = e.GetPosition(diagram)
			Dim link As DiagramLink = diagram.GetLinkAt(pt, 6, True)
			diagram.AllowLinkCursor = If(link Is Nothing, Cursors.No, Cursors.Hand)
		End If
	End Sub
End Class